// 002 u_gui_write_read
// 06 may 2005

// -- (C) Felix John COLIBRI 2004
// -- documentation: http://www.felix-colibri.com

(*$r+*)
unit u_gui_write_read;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls
        , u_c_stdin_stdout_process
         ;


type
  TForm1 = class(TForm)
    Memo1: TMemo;
    exit_: TButton;
    clear_: TButton;
    start_: TButton;
    kill_: TButton;
    Edit1: TEdit;
    do_write_: TButton;
    do_read_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure start_Click(Sender: TObject);
    procedure kill_Click(Sender: TObject);
    procedure do_write_Click(Sender: TObject);
    procedure do_read_Click(Sender: TObject);
  private
  public
   procedure handle_reception(p_c_stdin_stdout_process: c_stdin_stdout_process);
   procedure handle_stdin_stdout_process_error(p_c_stdin_stdout_process: c_stdin_stdout_process);
  end;

    var Form1: TForm1;

  implementation
    uses u_types_constants, u_c_log, u_c_display, u_display_hex_2
        , u_dir, u_file, u_exe
    ;

    {$R *.DFM}

    var g_c_stdin_stdout_process: c_stdin_stdout_process= Nil;

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.handle_reception(p_c_stdin_stdout_process: c_stdin_stdout_process);
      begin
        display('received '+ g_c_stdin_stdout_process.m_received_string);
      end; // handle_reception

    procedure TForm1.handle_stdin_stdout_process_error(p_c_stdin_stdout_process: c_stdin_stdout_process);
      begin
        display('error '+ p_c_stdin_stdout_process.m_error_text);
      end; // handle_stdin_stdout_process_error

    procedure TForm1.start_Click(Sender: TObject);
      begin
        g_c_stdin_stdout_process:= c_stdin_stdout_process.create_stdin_stdout_process('stdin_stdout_process');

        with g_c_stdin_stdout_process do
        begin
          // -- fill the start parameters

          m_exe_name:= f_exe_path+ '..\_exe\p_console_read_write.exe';
          if not FileExists(m_exe_name)
            then begin
                display('NO');
                Exit;
              end;

          // -- initialize the process parameters
          m_window_style:= wsNormal;
          m_do_call_process_messages:= True;
          m_on_output:= handle_reception;
          m_on_error:= handle_stdin_stdout_process_error;

          display('> go');
          if f_create_stdin_stdout_pipes
            then begin
                display('pipe_ok');
                if f_create_process
                  then display('process_ok')
                  else display('process NOK');
              end
            else display('pipe NOK')  ;
          display('< go');
        end;
      end; // start_Click

    procedure TForm1.do_write_Click(Sender: TObject);
      begin
        g_c_stdin_stdout_process.write_string(edit1.Text+ k_new_line);
      end; // do_write_Click

    procedure TForm1.do_read_Click(Sender: TObject);
      begin
        g_c_stdin_stdout_process.read_string;
      end; // do_read_Click

    procedure TForm1.kill_Click(Sender: TObject);
      begin
        g_c_stdin_stdout_process.do_stop_process;
      end; // kill_Click

    end.


